class DacChipControl
{
public:
    DacChipControl(DigitalOut cclk, DigitalOut cdti, DigitalOut csl, char us = 30): 
    CCLK(cclk), CDTI(cdti), CSL(csl) 
    {}

    int write(char reg, char dat)
    {
        char b;

        CSL = 1;
        wait_us(us);
        CCLK = 1;
        wait_us(us);
        CSL = 0;
        wait_us(us);

        b = 0x80;
        reg |= 0b00100000;

        while (b > 0)
        {
            SPI_bitset(reg&b);
            b = b >> 1;
        }

        b = 0x80;
        while (b > 0)
        {
            SPI_bitset(dat&b);
            b = b >> 1;
        }
        CSL = 1;
        return 0;
    }

private:
    DigitalOut CCLK;
    DigitalOut CDTI;
    DigitalOut CSL;
    char no;
    char us;

    void SPI_bitset(char bit)
    {
        CCLK = 0;   //Clk
        wait_us(us);
        if (bit > 0) CDTI = 1; else CDTI = 0;
        wait_us(us);
        CCLK = 1;   //Clk
        wait_us(us);
    }
};